diff --git a/core/connectors/connector.c b/core/connectors/connector.c
index d218383e..1185ee3c 100644
--- a/core/connectors/connector.c
+++ b/core/connectors/connector.c
@@ -10,7 +10,7 @@
 #include "sixaxis.h"
 #include "controllers/controller.h"
 #include "report.h"
-#include "tcp_con.h"
+#include "udp_con.h"
 #include "gpp_con.h"
 #include "usb_spoof.h"
 #ifndef WIN32
@@ -34,7 +34,6 @@ int connector_init()
   int ret = 0;
   int i;
   s_controller* control;
-  unsigned short port = TCP_PORT;
 
   for(i=0; i<MAX_CONTROLLERS; ++i)
   {
@@ -105,15 +104,27 @@ int connector_init()
           ret = -1;
         }
       }
-      else
+      else if(control->dst_ip)
       {
-        if(!control->dst_ip)
+        control->dst_fd = udp_connect(control->dst_ip, control->dst_port);
+        if(control->dst_fd < 0)
         {
-          control->dst_ip = INADDR_LOOPBACK;
-          control->dst_port = port;
-          ++port;
+          fprintf(stderr, _("Can't connect to port: %d.\n"), control->dst_port);
+          ret = -1;
         }
-        control->dst_fd = tcp_connect(control->dst_ip, control->dst_port);
+      }
+    }
+    if(control->src_ip)
+    {
+      control->src_fd = udp_listen(control->src_ip, control->src_port);
+      if(control->src_fd < 0)
+      {
+        fprintf(stderr, _("Can't listen on port: %d.\n"), control->src_port);
+        ret = -1;
+      }
+      else
+      {
+        GE_AddSource(control->src_fd, i, controller_network_read, udp_close);
       }
     }
   }
@@ -132,7 +143,7 @@ void connector_clean()
       case C_TYPE_DEFAULT:
         if(controller->dst_fd >= 0)
         {
-          tcp_close(controller->dst_fd);
+          udp_close(controller->dst_fd);
         }
         else if(controller->bdaddr_dst)
         {
@@ -173,7 +184,7 @@ int connector_send()
           }
           else if(controller->dst_fd >= 0)
           {
-            ret = tcp_send(controller->dst_fd, (unsigned char*)&report.value.ds3, report.value_len);
+            ret = udp_send(controller->dst_fd, (unsigned char*)controller->axis, sizeof(controller->axis));
           }
           break;
         case C_TYPE_GPP:
diff --git a/core/connectors/udp_con.c b/core/connectors/udp_con.c
index f2786ec3..82d3b413 100644
--- a/core/connectors/udp_con.c
+++ b/core/connectors/udp_con.c
@@ -12,6 +12,7 @@
 #endif
 #include <stdio.h>
 #include <unistd.h>
+#include <GE.h>
 
 int udp_listen(unsigned int ip, unsigned short port)
 {
@@ -65,7 +66,10 @@ unsigned int udp_send(int fd, unsigned char* buf, unsigned int len)
   return send(fd, buf, len, MSG_DONTWAIT);
 }
 
-void udp_close(int fd)
+int udp_close(int fd)
 {
   close(fd);
+  GE_RemoveSource(fd);
+
+  return 1;
 }
diff --git a/core/controllers/controller.c b/core/controllers/controller.c
index 2325d6c9..3b992b0f 100644
--- a/core/controllers/controller.c
+++ b/core/controllers/controller.c
@@ -10,6 +10,9 @@
 #include <stdio.h>
 #include <string.h>
 #include <sys/time.h>
+#include <errno.h>
+#include <unistd.h>
+#include <udp_con.h>
 
 static s_controller controller[MAX_CONTROLLERS] = {};
 
@@ -224,3 +227,27 @@ void controller_dump_state(s_controller* c)
 
   printf("\n");
 }
+
+int controller_network_read(int id)
+{
+  unsigned char buf[sizeof(controller->axis)];
+  int nread = 0;
+  int ret;
+  while(nread != sizeof(buf))
+  {
+    if((ret = read(controller[id].src_fd, buf+nread, sizeof(buf)-nread)) < 0)
+    {
+      if(errno != EAGAIN)
+      {
+        return -1;
+      }
+    }
+    else
+    {
+      nread += ret;
+    }
+  }
+  memcpy(controller[id].axis, buf, sizeof(controller->axis));
+  controller[id].send_command = 1;
+  return 0;
+}
diff --git a/core/emuclient.c b/core/emuclient.c
index 9a42de7b..f39d6187 100644
--- a/core/emuclient.c
+++ b/core/emuclient.c
@@ -200,10 +200,13 @@ int main(int argc, char *argv[])
 
   macros_init();
 
-  if(read_config_file(emuclient_params.config_file) < 0)
+  if(emuclient_params.config_file)
   {
-    fprintf(stderr, _("read_config_file failed\n"));
-    goto QUIT;
+    if(read_config_file(emuclient_params.config_file) < 0)
+    {
+      fprintf(stderr, _("read_config_file failed\n"));
+      goto QUIT;
+    }
   }
 
   if(GE_GetMKMode() == GE_MK_MODE_SINGLE_INPUT)
diff --git a/core/include/controllers/controller.h b/core/include/controllers/controller.h
index ce1b4cbc..83dd7bab 100644
--- a/core/include/controllers/controller.h
+++ b/core/include/controllers/controller.h
@@ -109,4 +109,6 @@ s_axis_index get_axis_index_from_name(const char*);
 
 void controller_dump_state(s_controller* c);
 
+int controller_network_read(int fd);
+
 #endif /* CONTROLLER_H_ */
diff --git a/core/include/udp_con.h b/core/include/udp_con.h
index 7c057f85..cb9b6de6 100644
--- a/core/include/udp_con.h
+++ b/core/include/udp_con.h
@@ -9,6 +9,6 @@
 int udp_listen(unsigned int ip, unsigned short port);
 int udp_connect(unsigned int ip, unsigned short port);
 unsigned int udp_send(int fd, unsigned char* buf, unsigned int len);
-void udp_close(int fd);
+int udp_close(int fd);
 
 #endif /* UDP_CON_H_ */
diff --git a/core/linux/mainloop.c b/core/linux/mainloop.c
index 524e68bb..ee91055e 100644
--- a/core/linux/mainloop.c
+++ b/core/linux/mainloop.c
@@ -27,7 +27,7 @@ void mainloop()
   struct timespec period = {.tv_sec = 0, .tv_nsec = emuclient_params.refresh_period*1000};
   unsigned int running_macros;
 
-  if(get_controller(0)->type != C_TYPE_DEFAULT)
+  if(!get_controller(0)->bdaddr_dst)
   {
     GE_TimerStart(&period);
   }
